{-# LANGUAGE DerivingStrategies #-}
{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DerivingVia #-}
module Language.Java.Classfile.Version (Version(..)) where

import Data.Word (Word16)
import GHC.Generics (Generic, Generically(Generically))
import Language.Java.Classfile.Extractable (Extractable)

data Version = Version
  { minor :: Word16
  , major :: Word16
  }
  deriving stock (Show, Generic)
  deriving Extractable via Generically Version

-- >>> import Language.Java.Classfile.Extractable (Extractable(extract))
-- >>> import Language.Java.Classfile.Extract (runExtract)
-- >>> :set -XOVerloadedLists
-- >>> runExtract (fromList [0, 0, 0, 0]) extract :: Version
-- Variable not in scope: fromList :: [a0_a3mwi[tau:1]] -> ByteString

